(******************************************************************************

______________________________________________________________________________

YTD v1.00                                                    (c) 2009-12 Pepak
http://www.pepak.net/ytd                                  http://www.pepak.net
______________________________________________________________________________


Copyright (c) 2009-12 Pepak (http://www.pepak.net)
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:
    * Redistributions of source code must retain the above copyright
      notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright
      notice, this list of conditions and the following disclaimer in the
      documentation and/or other materials provided with the distribution.
    * Neither the name of Pepak nor the
      names of his contributors may be used to endorse or promote products
      derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL PEPAK BE LIABLE FOR ANY
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

******************************************************************************)

unit downVimeo_Embed;
{$INCLUDE 'ytd.inc'}

interface

uses
  SysUtils, Classes,
  uPCRE, uXml, HttpSend,
  uDownloader, uCommonDownloader, uHttpDownloader, downVimeo;

type
  TDownloader_Vimeo_Embed = class(TDownloader_Vimeo)
    private
      fFrameReferer: string;
    protected
      function GetMovieInfoUrl: string; override;
    public
      class function UrlRegExp: string; override;
      constructor Create(const AMovieID: string); override;
      destructor Destroy; override;
      property FrameReferer: string read fFrameReferer write fFrameReferer;
    end;

implementation

uses
  uStringConsts,
  uDownloadClassifier,
  uMessages;

// http://player.vimeo.com/video/32373779
const
  URLREGEXP_BEFORE_ID = '^https?://(?:[a-z0-9-]+\.)*player\.vimeo\.com/(?:video/)?';
  URLREGEXP_ID =        '[0-9]+';
  URLREGEXP_AFTER_ID =  '';

const
  REGEXP_MOVIE_TITLE = REGEXP_TITLE_H1;
  REGEXP_CONFIG = '\{\s*"request"\s*:\s*\{(?P<CONFIG>.*?)\}';
  REGEXP_CONFIG_VARS = '"(?P<VARNAME>[^"]+)"\s*:\s*(?P<QUOTE>"?)(?P<VARVALUE>.*?)(?P=QUOTE)\s*,';

{ TDownloader_Vimeo }

class function TDownloader_Vimeo_Embed.UrlRegExp: string;
begin
  Result := Format(URLREGEXP_BEFORE_ID + '(?P<%s>' + URLREGEXP_ID + ')' + URLREGEXP_AFTER_ID, [MovieIDParamName]);;
end;

constructor TDownloader_Vimeo_Embed.Create(const AMovieID: string);
begin
  inherited Create(AMovieID);
end;

destructor TDownloader_Vimeo_Embed.Destroy;
begin
  inherited;
end;

function TDownloader_Vimeo_Embed.GetMovieInfoUrl: string;
begin
  Result := 'http://player.vimeo.com/video/' + MovieID;
end;

initialization
  RegisterDownloader(TDownloader_Vimeo_Embed);

end.
